#!/usr/bin/bash

# do_it_all.sh <optimization> -- Generate a Makefile and run it, and make graphs.

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


# default comiler optimization level is zero (no optimization)
optimization=${1:-0}

# Make the Makefile and compile to get object files.  

echo '---- Ignore any undefineds from linker...'
./maker.sh main $optimization
make clean
make

# make the graphs
./include_graph.sh
./call_graph.sh
./extern_graph.sh
./module_graph.sh
./source_list.sh

# clean up a bit
rm *.pdf

# make debug files
cp include_graph/==ALL==.pdf include_graph.pdf
cp call_graph/==ALL==.pdf call_graph.pdf
cp extern_graph/==ALL==.pdf extern_graph.pdf
cp module_graph/==ALL==.pdf module_graph.pdf

# wrap the result up in tarball for distribution
./package.sh

