#!/usr/bin/bash

# recursive_depends_on.sh <dbase> <node_name> -- filter to extract all
# nodes that recursivly depend on the specified <node_name> in the
# <dbase> file that holds a list of depends-on relationships.

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


######## use the iterative perl version ########


./recursive_depends_on.pl $1 $2 | sort -u
exit


################################################


# fetch parameters
dbase=$1
node_name=$2

# exit if nothing left to do
if [ -z $node_name ]
then exit
fi

# visit the root
echo $node_name

# visit the predecessors of the root
predecessors=`./depends_on.sh $dbase $node_name`

for node in $predecessors
do ./recursive_depends_on.sh $dbase $node
done

