#!/usr/bin/bash

# source_list.sh -- generate html colorized source listing files

# ----------------------------------------------------------------
# This file is part of code_graphs Copyright (C) 2011 Elijah 
# Laboratories Inc.  http://www.elilabs.com  ALL RIGHTS RESERVED.
#
# GNU cflow is free software; you can redistribute it and/or modify it
# under the terms of the GNU General Public License as published by the
# Free Software Foundation; either version 3 of the License, or (at your
# option) any later version.
#
# code_graphs is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with code_graphs; if not, write to the Free Software Foundation,
# Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA
# ----------------------------------------------------------------


# make the colorized html source files
for f in *.[ch]
do /usr/local/bin/c2html $f
done

# move them to their final home
rm -rf listings
mkdir listings
mv *.[ch].html listings/

# make the table of contents
cd listings
cat ../dir.head > dir.html

ls *.[ch].html \
 | sed 's/.html$//' \
 | awk -v qt='"' '{ print "     <a href=" qt $0 ".html" qt " target=contents>" $0 "</a><br>" }' - >> dir.html

cat ../dir.foot >> dir.html

# fix up title for browser
cat ../index.html.skel | sed 's/Dependency Graph Browser/Source Listings/' > index.html

cp ../empty.html .

